
local _G = _G
local emptyFunc = function() end

AMF = CreateFrame("frame")
local AMF = AMF
AMF:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
function AMF:Print(...) ChatFrame1:AddMessage(string.join(" ", "|cFF33FF99AMF|r:", ...)) end

local AMFScrollframe, AMFFilterBox, AMFFilterButton
local scrollloc = 0
function AMF:InitScrollFrame()
	self.AMFScrollframe = CreateFrame("ScrollFrame",nil,MerchantFrame)
	AMFScrollframe = self.AMFScrollframe
	AMFScrollframe:SetWidth(302)
	AMFScrollframe:SetHeight(294)
	AMFScrollframe:SetPoint("TOPLEFT", "MerchantFrame", "TOPLEFT", 21, -77)
	local child = CreateFrame("Frame")
		child:SetWidth(302)
		child:SetHeight(294)
	AMFScrollframe.child = child
	AMFScrollframe:SetScrollChild(child)
	local slider = CreateFrame('Slider')
		slider:SetParent(AMFScrollframe)
		slider:SetPoint("TOPLEFT", AMFScrollframe, "TOPRIGHT",0,-16)
		slider:SetPoint("BOTTOMLEFT", AMFScrollframe, "BOTTOMRIGHT",0,15)
		slider:SetWidth(16)
		slider:SetOrientation("VERTICAL")
		slider:EnableMouseWheel(true)
		local ScrollUpButton = CreateFrame('Button',nil,slider,'UIPanelScrollUpButtonTemplate')
			ScrollUpButton:SetPoint('BOTTOM', slider, 'TOP')
		slider.ScrollUpButton = ScrollUpButton
		local ScrollDownButton = CreateFrame('Button',nil,slider,'UIPanelScrollDownButtonTemplate')
			ScrollDownButton:SetPoint('TOP', slider, 'BOTTOM')
		slider.ScrollDownButton = ScrollDownButton
		slider:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
		local thumb = slider:GetThumbTexture()
			thumb:SetWidth(16) thumb:SetHeight(16)
			thumb:SetTexCoord(1/4, 3/4, 1/4, 3/4)
		slider.ScrollUpButton:SetScript('OnClick', function(self)
			local parent = self:GetParent();
			parent:SetValue(parent:GetValue() - 16);
			PlaySound("UChatScrollButton");
		end)
		slider.ScrollDownButton:SetScript('OnClick', function(self)
			local parent = self:GetParent();
			parent:SetValue(parent:GetValue() + 16);
			PlaySound("UChatScrollButton");
		end)
		slider:SetScript('OnMouseWheel', function(self, arg1)
			self:SetValue(self:GetValue() - (arg1*16))
		end)
		slider:SetScript('OnValueChanged', function(self, value)
			scrollloc = value
			local min, max = self:GetMinMaxValues()
			if value == min then
				self.ScrollUpButton:Disable()
			else
				self.ScrollUpButton:Enable()
			end
			if value == max then
				self.ScrollDownButton:Disable()
			else
				self.ScrollDownButton:Enable()
			end
			AMFScrollframe:SetVerticalScroll(value)
		end)
	AMFScrollframe.slider = slider
	AMFScrollframe:SetScript('OnScrollRangeChanged', function(self,y,x)
		self.slider:SetMinMaxValues(0, x)
		if self.slider:GetValue() > x then
			self.slider:SetValue(x)
		end
	end)
	
	-- Filter box
	self.AMFFilterBox = CreateFrame("EditBox", nil, MerchantFrame)
	AMFFilterBox = self.AMFFilterBox
	local Left = AMFFilterBox:CreateTexture(nil, "BACKGROUND")
		Left:SetTexture([[Interface\Common\Common-Input-Border]])
		Left:SetTexCoord(0,.0625,0,.625)
		Left:SetWidth(8)
		Left:SetHeight(20)
		Left:SetPoint("LEFT",AMFFilterBox,"LEFT",-5,0)
		Left:SetBlendMode("ADD")
		Left:SetAlpha(.75)
	AMFFilterBox.Left = Left
	local Right = AMFFilterBox:CreateTexture(nil, "BACKGROUND")
		Right:SetTexture([[Interface\Common\Common-Input-Border]])
		Right:SetTexCoord(.9375,1,0,.625)
		Right:SetWidth(8)
		Right:SetHeight(20)
		Right:SetPoint("RIGHT",AMFFilterBox,"RIGHT",0,0)
		Right:SetBlendMode("ADD")
		Right:SetAlpha(.75)
	AMFFilterBox.Right = Right
	local Middle = AMFFilterBox:CreateTexture(nil, "BACKGROUND")
		Middle:SetTexture([[Interface\Common\Common-Input-Border]])
		Middle:SetTexCoord(.0625,.9375,0,.625)
		Middle:SetHeight(20)
		Middle:SetPoint("LEFT",AMFFilterBox.Left,"RIGHT")
		Middle:SetPoint("RIGHT",AMFFilterBox.Right,"LEFT")
		Middle:SetBlendMode("ADD")
		Middle:SetAlpha(.75)
	AMFFilterBox.Middle = Middle
	AMFFilterBox:SetWidth(100)
	AMFFilterBox:SetHeight(20)
	AMFFilterBox:SetPoint("TOPLEFT", "MerchantFrame", "TOPLEFT", 85, -45)
	AMFFilterBox:SetAutoFocus(false)
	AMFFilterBox:SetFontObject(ChatFontNormal)
	AMFFilterBox:EnableMouse(true)
	AMFFilterBox:SetScript('OnEscapePressed', function(self) self:ClearFocus() end)
	AMFFilterBox:SetScript('OnEditFocusLost', function(self) self:HighlightText(0, 0) end)
	AMFFilterBox:SetScript('OnEditFocusGained', function(self) self:HighlightText() end)
	AMFFilterBox:SetScript('OnCursorChanged', function(self)
		AMF:SetupMerchantFrame()
	end)
	
	-- Filter Button
	self.AMFFilterButton =  CreateFrame('Button',nil,MerchantFrame,'UIPanelButtonTemplate')
	AMFFilterButton = self.AMFFilterButton
	AMFFilterButton:SetWidth(100)
	AMFFilterButton:SetHeight(20)
	AMFFilterButton:SetPoint("TOPLEFT", AMFFilterBox, "TOPRIGHT", 5,0)
	AMFFilterButton:SetText('Filter')
	AMFFilterButton:SetScript('OnClick', function(self)
		ToggleDropDownMenu(1, nil, AMF.FilterDropDownMenu, self, 0, 0)
	end)
end

local ItemFrameStack = {}
local merchantname = ''
function AMF:SetupMerchantFrame()
	if not AMFScrollframe then AMF:InitScrollFrame() end -- create scroll frame if its the first time we need it
	if merchantname ~= UnitName('NPC') then
		merchantname = UnitName('NPC')
		AMFFilterBox:SetText('Search...')
		scrollloc = 0
		AMF.Filter_USABLE_ITEMS = nil
		AMF.Filter_EQUIPPABLE_ITEMS = nil
		AMF.Filter = AMF:WipeTable(AMF.Filter)
	end
	-- clear out old items
	AMFScrollframe:Show()
	for i=1,#ItemFrameStack do
	ItemFrameStack[i] = AMF:RecycleItemFrame(ItemFrameStack[i])
	end
	-- setup new things hurray
	local numMerchantItems = GetMerchantNumItems();
	local even = false
	local FNUM = 0
	local pattern = AMFFilterBox:GetText()
	if pattern == 'Search...' then
		pattern = ''
	else
		pattern = string.lower(pattern)
	end
	
	
	for i=1,numMerchantItems do
		local name = string.lower(GetMerchantItemInfo(i) or '')
		if string.find(name, pattern) and GetMerchantItemLink(i) then
			local _, _, _, _, _, isUsable = GetMerchantItemInfo(i)
			local _, _, _, _, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(GetMerchantItemLink(i))
			if (not AMF.Filter_USABLE_ITEMS or isUsable)
			and (not next(AMF.Filter) or AMF.Filter[itemType])
			and (not AMF.Filter[itemType] or not next(AMF.Filter[itemType]) or AMF.Filter[itemType][itemSubType])
			and (not AMF.Filter_EQUIPPABLE_ITEMS or itemEquipLoc ~= '')
			and (not AMF.Filter_EQUIPPABLE_ITEMS or not next(AMF.Filter_EQUIPPABLE_ITEMS) or AMF.Filter_EQUIPPABLE_ITEMS[_G[itemEquipLoc]]) then
				if true then
					FNUM = FNUM+1
					ItemFrameStack[FNUM] = AMF:GetItemFrame(i, even)
					even = not even
					ItemFrameStack[FNUM]:SetParent(AMFScrollframe.child)
					if FNUM == 1 then
						ItemFrameStack[FNUM]:SetPoint('TOPLEFT', AMFScrollframe.child,'TOPLEFT')
					else
						ItemFrameStack[FNUM]:SetPoint('TOPLEFT', ItemFrameStack[FNUM-1], 'BOTTOMLEFT')
					end
				end
			end
		end
	end
	AMFScrollframe.child:SetHeight(FNUM*32)
	local scrollrange = AMFScrollframe:GetVerticalScrollRange()
	if scrollrange == 0 then scrollrange = 1 end
	if not scrollloc then scrollloc = 0 end
	AMFScrollframe.slider:SetMinMaxValues(0, scrollrange)
	AMFScrollframe.slider:SetValue(scrollloc)
	return
end

local MerchantFrame_UpdateMerchantInfo_Orig = MerchantFrame_UpdateMerchantInfo
function MerchantFrame_UpdateMerchantInfo()
	MerchantNameText:SetText(UnitName("NPC"));
	SetPortraitTexture(MerchantFramePortrait, "NPC");
	for i=1,12 do
		_G["MerchantItem"..i.."ItemButton"]:Hide()
		_G["MerchantItem"..i]:Hide()
		_G["MerchantItem"..i.."MoneyFrame"]:Hide()
		_G["MerchantItem"..i.."AltCurrencyFrame"]:Hide()
	end
	_G["MerchantNextPageButton"]:Hide()
	_G["MerchantPrevPageButton"]:Hide()
	_G["MerchantPageText"]:Hide()
	
	-- Handle repair items
	MerchantFrame_UpdateRepairButtons();
	-- Handle vendor buy back item
	local buybackName, buybackTexture, buybackPrice, buybackQuantity, buybackNumAvailable, buybackIsUsable = GetBuybackItemInfo(GetNumBuybackItems());
	if ( buybackName ) then
		MerchantBuyBackItemName:SetText(buybackName);
		SetItemButtonCount(MerchantBuyBackItemItemButton, buybackQuantity);
		SetItemButtonStock(MerchantBuyBackItemItemButton, buybackNumAvailable);
		SetItemButtonTexture(MerchantBuyBackItemItemButton, buybackTexture);
		MerchantBuyBackItemMoneyFrame:Show();
		MoneyFrame_Update("MerchantBuyBackItemMoneyFrame", buybackPrice);
		MerchantBuyBackItem:Show();
		
	else
		MerchantBuyBackItemName:SetText("");
		MerchantBuyBackItemMoneyFrame:Hide();
		SetItemButtonTexture(MerchantBuyBackItemItemButton, "");
		SetItemButtonCount(MerchantBuyBackItemItemButton, 0);
		-- Hide the tooltip upon sale
		if ( GameTooltip:IsOwned(MerchantBuyBackItemItemButton) ) then
			GameTooltip:Hide();
		end
	end
	
	-- Show all merchant related items
	MerchantBuyBackItem:Show();
	MerchantFrameBottomLeftBorder:Show();
	MerchantFrameBottomRightBorder:Show();

	-- Hide buyback related items
	BuybackFrameTopLeft:Hide();
	BuybackFrameTopRight:Hide();
	BuybackFrameBotLeft:Hide();
	BuybackFrameBotRight:Hide();
	
	-- Position merchant items
	MerchantItem3:SetPoint("TOPLEFT", "MerchantItem1", "BOTTOMLEFT", 0, -8);
	MerchantItem5:SetPoint("TOPLEFT", "MerchantItem3", "BOTTOMLEFT", 0, -8);
	MerchantItem7:SetPoint("TOPLEFT", "MerchantItem5", "BOTTOMLEFT", 0, -8);
	MerchantItem9:SetPoint("TOPLEFT", "MerchantItem7", "BOTTOMLEFT", 0, -8);
	
	AMF:SetupMerchantFrame()
	--MerchantFrame_UpdateMerchantInfo_Orig() -- use for debug if you want to see original frames
end
	
local MerchantFrame_UpdateBuybackInfo_orig = MerchantFrame_UpdateBuybackInfo
function MerchantFrame_UpdateBuybackInfo()
	AMFScrollframe:Hide()
	for i=1,12 do
		_G["MerchantItem"..i.."ItemButton"]:Show()
		_G["MerchantItem"..i]:Show()
		_G["MerchantItem"..i.."MoneyFrame"]:Show()
		_G["MerchantItem"..i.."AltCurrencyFrame"]:Show()
	end
	_G["MerchantNextPageButton"]:Show()
	_G["MerchantPrevPageButton"]:Show()
	_G["MerchantPageText"]:Show()
	MerchantFrame_UpdateBuybackInfo_orig()
end

function AMF:ItemButton_OnClick(icon, button)
	if IsModifiedClick() then
		if IsModifiedClick("SPLITSTACK") then
			local maxStack = GetMerchantItemMaxStack(icon:GetID());
			if ( maxStack > 1 ) then
				if ( price and (price > 0) ) then
					local canAfford = floor(GetMoney() / price);
					if ( canAfford < maxStack ) then
						maxStack = canAfford;
					end
				end
				OpenStackSplitFrame(maxStack, icon, "BOTTOMLEFT", "TOPLEFT");
			end
		else
			HandleModifiedItemClick(GetMerchantItemLink(icon:GetID()))
		end
	else
		if ( button == "LeftButton" ) then
			local frame = icon:GetParent()
			frame.buyquantity:SetFocus()
		else
			if ( icon.extendedCost ) then
				MerchantFrame_ConfirmExtendedItemCost(icon);
			else
				self:StartBuyItem(icon)
			end
		end
	end
end


local function SplitStack(button, split)
	if ( button.extendedCost ) then
		MerchantFrame_ConfirmExtendedItemCost(button, split)
	elseif ( split > 0 ) then
		BuyMerchantItem(button:GetID(), split);
	end
end

-- GetMerchantItemInfo(1) => "Refreshing Spring Water", "Interface\Icons\INV_Drink_07", 20, 5, -1, 1, nil
local framestack = {}
function AMF:GetItemFrame(ID,even)
	local frame
	if not next(framestack) then
		--create basic frame form
		frame = CreateFrame('Frame') -- base frame
		frame:SetHeight(32)
		frame:SetWidth(302)
		local backdrop = frame:CreateTexture(nil, "BACKGROUND")
			backdrop:SetTexture([[Interface\Tooltips\UI-Tooltip-Background]])
			backdrop:SetAllPoints(frame)
		frame.backdrop = backdrop
		frame:EnableMouseWheel(true)
		frame:SetScript('OnMouseWheel', function(self, arg1)
			AMFScrollframe.slider:SetValue(AMFScrollframe.slider:GetValue() - (arg1*16))
		end)

		local icon = CreateFrame('Button',nil,frame)
			icon:SetHeight(28)
			icon:SetWidth(28)
			icon:SetFrameStrata("HIGH")
			icon:SetPoint('TOPLEFT',frame,'TOPLEFT',2,-2)
			icon:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
			icon:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]], "ADD")
			icon:RegisterForClicks("LeftButtonUp","RightButtonUp");
			icon:RegisterForDrag("LeftButton")
			icon.SplitStack = SplitStack
			local Stock = icon:CreateFontString()
				Stock:SetFont([[Fonts\ARIALN.TTF]],10,"OUTLINE")
				Stock:SetTextColor(1, .82, 0)
				Stock:SetPoint("TOPLEFT", icon, "TOPLEFT", 0,-2)
			icon.Stock = Stock
			icon:SetScript('OnClick', function(self, button)
					AMF:ItemButton_OnClick(self, button);
				end)
			icon:SetScript('OnDragStart', function(self, button)
					MerchantFrame.extendedCost = nil;
					PickupMerchantItem(self:GetID());
					if ( self.extendedCost ) then
						MerchantFrame.extendedCost = self;
					end
				end)
			icon:SetScript('OnEnter', function(self)
					GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
					GameTooltip:SetMerchantItem(self:GetID())
					GameTooltip_ShowCompareItem();
					MerchantFrame.itemHover = self:GetID()
				end)
			icon:SetScript('OnLeave', function()
					GameTooltip:Hide();
					ResetCursor();
					MerchantFrame.itemHover = nil
				end)
			icon:EnableMouseWheel(true)
			icon:SetScript('OnMouseWheel', function(self, arg1)
				AMFScrollframe.slider:SetValue(AMFScrollframe.slider:GetValue() - (arg1*16))
			end)
		frame.SetItemStock = function(self, stock)
			if not stock then stock = "" end
			if stock > 0 then
				self.icon.Stock:SetFormattedText(MERCHANT_STOCK,stock)
				self.icon.Stock:Show()
			else
				self.icon.Stock:Hide()
			end
		end
		local iconTexture = frame:CreateTexture(nil,"BORDER")
			iconTexture:SetTexture([[Interface\Icons\Temp]])
			iconTexture:SetAllPoints(icon)
		frame.iconTexture = iconTexture
		frame.icon = icon
		local buyquantity = CreateFrame("EditBox",nil,frame)
			buyquantity:SetAutoFocus(false)
			buyquantity:SetFont([[Fonts\ARIALN.TTF]],10,"OUTLINE")
			buyquantity:SetTextColor(1, 1, 1)
			buyquantity:SetHeight(12)
			buyquantity:SetWidth(30)
			buyquantity:SetPoint("BOTTOMRIGHT", icon, "BOTTOMRIGHT", -3,1)
			buyquantity:SetFrameStrata("MEDIUM")
			buyquantity:SetJustifyH("RIGHT")
			buyquantity:SetMaxLetters(3)
			buyquantity:SetNumeric(true)
			buyquantity:SetScript('OnEscapePressed', function(self) self:ClearFocus() end)
			buyquantity:SetScript('OnEditFocusLost', function(self) 
				self:SetNumber(frame.stacksize)
			end)
			buyquantity:SetScript('OnEditFocusGained', function(self)
				if self:GetText() == '' then self:SetNumber(1) end
				self:HighlightText() 
			end)
			buyquantity:SetScript('OnCursorChanged', function(self)
				if self:GetNumber() < 0 then
					self:SetNumber(math.abs (self:GetNumber()))
				end
				if self:GetNumber() == 1 and not self:HasFocus() then
					self:SetText('')
				end
				local frame = self:GetParent()
				local ID = frame:GetID()
				local buyamount = math.ceil(self:GetNumber()/frame.stacksize)
				if buyamount == 0 then buyamount = 1 end
				if frame.Price > 0  then
					frame.ItemPrice:SetText(frame.Price*buyamount)
				end
				if frame.icon.extendedCost then
					for i=1,#frame.altstack do
						frame.altstack[i].amount:SetText(frame.altstack[i].price*buyamount)
					end
				end
			end)
			buyquantity:SetScript('OnShow', function(self)
				if self:GetNumber() < 0 then
					self:SetNumber(math.abs (self:GetNumber()))
				end
			end)
			buyquantity:SetScript('OnEnterPressed', function(self)
				AMF:StartBuyItem(self)
			end)
		frame.buyquantity = buyquantity
		
		
		local ItemName = frame:CreateFontString()
			ItemName:SetFontObject("GameFontNormalSmall")
			ItemName:SetPoint('TOPLEFT',frame,'TOPLEFT',32,0)
			ItemName:SetPoint('BOTTOMRIGHT',frame,'BOTTOMRIGHT',0,16)
			ItemName:SetJustifyH("LEFT")
			ItemName:SetText('This is an Item Name')
		frame.ItemName = ItemName
		
		local ItemPrice = frame:CreateFontString()
			ItemPrice:SetFontObject("GameFontNormalSmall")
			ItemPrice:SetTextColor(1, 1, 1)
			ItemPrice:SetPoint('TOPLEFT',ItemName,'BOTTOMLEFT',0,-1)
			ItemPrice:SetJustifyH("RIGHT")
			--ItemPrice:SetText('99999999')
			ItemPrice.SetTextOld = ItemPrice.SetText
			ItemPrice.SetText = function(self, text)
				if text then
					self:SetTextOld(GetCoinTextureString(text))
					self:SetWidth(200)
					self:SetWidth(self:GetStringWidth())
				else
					self:SetTextOld('')
					self:SetWidth(0)
				end
			end
			ItemPrice:SetText(0)
		frame.ItemPrice = ItemPrice
		local ItemLevel = frame:CreateFontString()
			ItemLevel:SetFontObject("GameFontNormalSmall")
			ItemLevel:SetHeight(16)
			ItemLevel:SetPoint('BOTTOMRIGHT',frame,'BOTTOMRIGHT',-2,2)
			ItemLevel:SetText('iL 216')
		frame.ItemLevel = ItemLevel
	else
		--get basic frame form from stack
		frame = framestack[#framestack]
		framestack[#framestack] = nil
	end
	
	-- apply the Item
	frame:SetID(ID)
	frame.icon:SetID(ID)
	local itemName, itemTexture, itemPrice, itemStackCount, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(ID)
	local _, itemLink, itemRarity, itemLevel
	if GetMerchantItemLink(ID) then
		_, itemLink, itemRarity, itemLevel = GetItemInfo(GetMerchantItemLink(ID))
	else
		itemLink = GetMerchantItemLink(ID)
		itemRarity, itemLevel = 1, '???'
	end
	frame.iconTexture:SetTexture(itemTexture)
	frame.ItemLevel:SetText('iL '..itemLevel)
	frame.ItemName:SetText(itemName)
	frame:SetItemStock(numAvailable)
	frame.stacksize = itemStackCount
	if itemStackCount == 1 then itemStackCount = '' end
	frame.buyquantity:SetText(itemStackCount)
	if extendedCost and (itemPrice <= 0) then
		frame.icon.extendedCost = true
		frame.icon.link = itemLink
		frame.icon.texture = itemTexture
		frame.ItemPrice:SetText()
		frame.Price = 0
		self:AddAltCurrency(frame,ID)
	elseif extendedCost and (itemPrice > 0) then
		frame.icon.extendedCost = true
		frame.icon.link = itemLink
		frame.icon.texture = itemTexture
		frame.ItemPrice:SetText(itemPrice)
		frame.Price = itemPrice
		self:AddAltCurrency(frame,ID)
	else
		frame.icon.extendedCost = nil
		frame.ItemPrice:SetText(itemPrice)
		frame.Price = itemPrice
	end
	
	local r, g, b = GetItemQualityColor(itemRarity)
	frame.ItemName:SetTextColor(r, g, b)
	local gm = 1
	if even then
		gm = 2
	end
	local br, bg, bb = .25,.25,.25
	if isUsable then
		frame.backdrop:SetGradientAlpha("HORIZONTAL", br*gm,bg*gm,bb*gm, 0.5, br*gm,bg*gm,bb*gm, 0)
		frame.iconTexture:SetVertexColor(1, 1, 1)
	else
		frame.backdrop:SetGradientAlpha("HORIZONTAL", .5*gm,0,0, 0.5, .5*gm,0,0, 0)
		frame.iconTexture:SetVertexColor(.9, 0, 0)
	end
	frame:Show()
	return frame
end




function AMF:StartBuyItem(frame)
	local parent = frame:GetParent()
	local ID = parent:GetID()
	local _, _, _, itemStackCount, numAvailable = GetMerchantItemInfo(ID)
	local quantity = parent.buyquantity:GetNumber()
	if quantity == 0 then quantity = 1 end
	scrollloc = AMFScrollframe.slider:GetValue()
	if numAvailable < 0 then
		AMF:BuyItem(ID, quantity, itemStackCount)
	elseif numAvailable > 0 then
		if quantity > numAvailable then
			AMF:BuyItem(ID, numAvailable, itemStackCount)
		else
			AMF:BuyItem(ID, quantity, itemStackCount)
		end
		AMF:SetupMerchantFrame()
	else
		AMF:SetupMerchantFrame()
	end
	parent.buyquantity:ClearFocus()
end

function AMF:BuyItem(ID,quantity,itemStackCount)
	if GetMerchantItemLink(ID) then
		local _, _, _, _, _, _, _, itemStackSize = GetItemInfo(GetMerchantItemLink(ID))
		local buyamount = math.ceil(quantity/itemStackCount)
		itemStackSize = math.floor(itemStackSize/itemStackCount)
		while buyamount > 0 do
			if buyamount < itemStackSize then
				BuyMerchantItem(ID, buyamount)
				buyamount = 0
			else
				BuyMerchantItem(ID, itemStackSize)
				buyamount = buyamount - itemStackSize
			end
		end
	end
end

function AMF:AddAltCurrency(frame,ID)
	frame.altstack = {}
	local honorPoints, arenaPoints, itemCount = GetMerchantItemCostInfo(ID)
	if honorPoints > 0 then
		frame.altstack[1] = self:GetAltCurrencyFrame(honorPoints,HONOR_POINTS)
	end
	if arenaPoints > 0 then
		frame.altstack[#frame.altstack+1] = self:GetAltCurrencyFrame(arenaPoints,ARENA_POINTS)
	end
	for i=1, itemCount do
		frame.altstack[#frame.altstack+1] = self:GetAltCurrencyFrame(ID,i)
	end
	for i=1,#frame.altstack do
		if i==1 then
			frame.altstack[i]:SetPoint('TOPLEFT', frame.ItemPrice, 'TOPRIGHT',0,0)
		else
			frame.altstack[i]:SetPoint('TOPLEFT', frame.altstack[i-1], 'TOPRIGHT')
		end
		frame.altstack[i]:SetParent(frame)
	end
end

function AMF:RecycleItemFrame(frame)
	--cleanup our frame
	if frame.altstack then
		for i=1, #frame.altstack do
			frame.altstack[i] = self:RecycleAltCurrencyFrame(frame.altstack[i])
		end
	end
	frame:ClearAllPoints()
	frame:Hide()
	framestack[#framestack+1] = frame
	return nil
end

local altcurrencystack = {}
function AMF:GetAltCurrencyFrame(index,itemIndex)
	local frame
	if not next(altcurrencystack) then
		frame = CreateFrame('Button') -- base frame
		frame:SetHeight(16)
		local icon = frame:CreateTexture(nil,"OVERLAY")
			icon:SetHeight(12)
			icon:SetWidth(12)
			icon:SetPoint("TOPRIGHT",frame,"TOPRIGHT",0,0)
		frame.icon = icon
		local amount = frame:CreateFontString()
			amount:SetFont([[Fonts\ARIALN.TTF]],10,"OUTLINE")
			amount:SetTextColor(1, 1, 1)
			amount:SetPoint('TOPLEFT',frame,'TOPLEFT',1,0)
			amount:SetJustifyH("LEFT")
			amount.SetTextOld = amount.SetText
			function amount.SetText(self,text)
				self:SetTextOld(text)
				frame:SetWidth(0+14+self:GetStringWidth())
			end
			amount:SetText(1)
		frame.amount = amount
		frame:SetScript("OnLeave", function()
			GameTooltip:Hide();
			ResetCursor();
		end)
		frame:EnableMouseWheel(true)
		frame:SetScript('OnMouseWheel', function(self, arg1)
			AMFScrollframe.slider:SetValue(AMFScrollframe.slider:GetValue() - (arg1*16))
		end)
	else
		--get basic frame form from stack
		frame = altcurrencystack[#altcurrencystack]
		altcurrencystack[#altcurrencystack] = nil
	end
	
	local texture, price
	if itemIndex == HONOR_POINTS then
		price = index
		local factionGroup = UnitFactionGroup("player");
		texture = "Interface\\TargetingFrame\\UI-PVP-Horde";
		if ( factionGroup ) then
			texture = "Interface\\TargetingFrame\\UI-PVP-"..factionGroup;
		end
		frame:SetScript("OnEnter", function(self, frame)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:SetText(HONOR_POINTS);
		end)
	elseif itemIndex == ARENA_POINTS then
		price = index
		texture = "Interface\\PVPFrame\\PVP-ArenaPoints-Icon"
		frame:SetScript("OnEnter", function(self, frame)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:SetText(ARENA_POINTS);
		end)
	else
		texture, price = GetMerchantItemCostItem(index, itemIndex)
		frame.index = index
		frame.itemIndex = itemIndex
		frame:SetScript("OnEnter", function(self, frame)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:SetMerchantCostItem(self.index, self.itemIndex);
		end)
	end
	frame.icon:SetTexture(texture)
	if itemIndex == HONOR_POINTS then
		frame.icon:SetTexCoord(0,.6,0,.6)
	else
		frame.icon:SetTexCoord(0,1,0,1)
	end
	frame.price = price
	frame.amount:SetText(price)
	frame:Show()
	return frame
end

function AMF:RecycleAltCurrencyFrame(frame)
	--cleanup our frame
	frame:SetWidth(256)
	frame:ClearAllPoints()
	frame:Hide()
	altcurrencystack[#altcurrencystack+1] = frame
	return nil
end

